/*:
 * NOTE: Wszystkie skrypty, które musiałem zrobić, aby gra działała tak jak chcę.
 *
 * @plugindesc Wszystkie skrypty, które musiałem zrobić, aby gra działała tak jak chcę.
 * @author EnterVPL
 *
 * @help Póki co nie ma nic do ustawiania
 *
 */

// Zmiana widoku kamery
Game_Player.prototype.centerX = function() {
    // return (Graphics.width / $gameMap.tileWidth() - 20) / 2.0;
    return 3;
};

// Wywalenie statów oraz golda z menu pod ESC
Scene_Menu.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createCommandWindow();
};

Scene_Menu.prototype.createGoldWindow = function() {
    this._goldWindow = new Window_Gold(0, 0);
    this._goldWindow.setBackgroundType(1);
    this.addWindow(this._goldWindow);
}

// Usunięcie this._statusWindow.refresh(); - ponieważ ten obiekt usunąłem
Scene_Menu.prototype.start = function() {
    Scene_MenuBase.prototype.start.call(this);
};

// Zmiana pozycji command window (menu pod ESC)
Scene_Menu.prototype.createCommandWindow = function() {
    this._commandWindow = new Window_MenuCommand(0, 120);
    this._commandWindow.setHandler('options',   this.commandOptions.bind(this));
    this._commandWindow.setHandler('save',      this.commandSave.bind(this));
    this._commandWindow.setHandler('gameEnd',   this.commandGameEnd.bind(this));
    this._commandWindow.setHandler('shop',      this.shop.bind(this));
    this._commandWindow.setHandler('cancel',    this.popScene.bind(this));
    this.addWindow(this._commandWindow);
};

Window_ShopCommand.prototype.makeCommandList = function() {
    this.addCommand(TextManager.buy,    'buy');
    this.addCommand(TextManager.cancel, 'cancel');
};

Window_ShopCommand.prototype.maxCols = function() {
    return 2;
};

Game_Party.prototype.shopItems = function() {
    var level = this.gameLevel || 1;
    const bonus = {
        1: [
            [0, 1, 1, 10],          // 1/s
            [0, 2, 1, 100],         // 10/s
            [0, 3, 1, 1000],        // 100/s
            [0, 4, 1, 10000],       // 1000/s
            [0, 5, 1, 100],         // Chicken
            [0, 6, 1, 100],         // Jump
            [0, 7, 1, 100],         // Butterfly
        ],
        2: [
            [0, 1, 1, 20],          // 1/s
            [0, 2, 1, 250],         // 10/s
            [0, 3, 1, 3500],        // 100/s
            // [0, 4, 1, 40000],    // 1000/s
            [0, 5, 1, 200],         // Chicken
            // [0, 6, 1, 300],         // Jump
            [0, 7, 1, 400],         // Butterfly
            [0, 8, 1, 800],         // Fly
            [0, 9, 1, 1600],        // Milk
            [0, 10, 1, 5700],       // Milk furry
        ],
        3: [
            [0, 1, 1, 100],          // 1/s
            [0, 2, 1, 2570],         // 10/s
            [0, 3, 1, 35600],        // 100/s
            // [0, 4, 1, 40000],    // 1000/s
            [0, 5, 1, 800],         // Chicken
            // [0, 6, 1, 300],         // Jump
            [0, 7, 1, 900],         // Butterfly
            [0, 8, 1, 1000],         // Fly
            [0, 9, 1, 2000],        // Milk
            [0, 10, 1, 65700],       // Milk furry
            [0, 11, 1, 38000],       // Boxes
        ]
    };
    return bonus[level];
};

Game_Party.prototype.addGold = function(itemId, withOutBust, bust = 1) {
    if(itemId == 0) {
        var bust_1 = this._items[1] || 0;
        var bust_10 = this._items[2] || 0;
        bust_10 *= 10;
        var bust_100 = this._items[3] || 0;
        bust_100 *= 100;
        var bust_1000 = this._items[4] || 0;
        bust_1000 *= 1000;
        var bust_boxes = this._hasBoxes * (this._items[11] * 10 || 0);
        var bust = this._multiplier * (bust_1 + bust_10 + bust_100 + bust_1000 + bust_boxes);
        this._gold +=  bust;
        this._goldBonus = bust;
    } else if(itemId != 10) {
        var bustCount = this._items[itemId] || 0;
        this._gold += this._multiplier * (withOutBust + bust * bustCount);
    } else {
        var multiplier = this._items[itemId] || 0;
        multiplier *= withOutBust;
        this._multiplier = (multiplier == 0) ? 1 : multiplier;
        clearInterval(this._multiplierTimeout);
        const that = this;
        this._multiplierTimeout = setTimeout(function() {
            that._multiplier = 1;
        }, withOutBust * 1000);
    }
    
}

Game_Party.prototype.lostRandomBonus = function() {
    var has_items = Object.keys(this._items);
    var random = Math.floor(Math.random() * has_items.length);
    delete this._items[has_items[random]];
};

Game_Party.prototype.lostAllBonus = function() {
    this._items = {};
};

Game_Party.prototype.hasFullBonus = function() {
    const items = this.shopItems();
    if(Object.keys(items).length != Object.keys(this._items).length) {
        return false;
    }
    for(var itemIndex in $gameParty._items) {
        if($gameParty._items[itemIndex] != 99) return false;
    }
    
    return true;
};

// Wywołanie sceny sklepu z określonymi dobrami
Scene_Menu.prototype.shop = function() {  
    // Ustawienie dóbr
    Scene_Shop.prototype.initialize = function() {
        Scene_MenuBase.prototype.initialize.call(this);
        this.prepare($gameParty.shopItems(), true);
    };

    // Usunięcie sell ze sklepu
    Scene_Shop.prototype.createCommandWindow = function() {
        this._commandWindow = new Window_ShopCommand(this._goldWindow.x, this._purchaseOnly);
        this._commandWindow.y = this._helpWindow.height;
        this._commandWindow.setHandler('buy',    this.commandBuy.bind(this));
        this._commandWindow.setHandler('cancel', this.popScene.bind(this));
        this.addWindow(this._commandWindow);
    };
    

    SceneManager.push(Scene_Shop);
}

Window_MenuCommand.prototype.makeCommandList = function() {
    this.addShopCommand();
    this.addMainCommands();
    this.addFormationCommand();
    this.addOriginalCommands();
    this.addOptionsCommand();
    this.addSaveCommand();
    this.addGameEndCommand();
};

Window_MenuCommand.prototype.addShopCommand = function () {
    this.addCommand("Sklep", 'shop', true);
}

// Usunięcie blur z tła z menu pod esc
SceneManager.snapForBackground = function() {
    this._backgroundBitmap = this.snap();
};

// Usunięcie zbędnych ustawień
Window_Options.prototype.addGeneralOptions = function() {
};

// podmianka widoku mapy
Scene_Map.prototype.createAllWindows = function() {
    this.createMessageWindow();
    this.createScrollTextWindow();
    this.createGoldPerSecWindow();
};

Scene_Title.prototype.createWindowLayerBackground = function() {
    this._windowLayerBackground = new Sprite();
    this._windowLayerBackground.bitmap = ImageManager.loadPicture("mainMenuSprite");
    this._windowLayerBackground.x = 20;
    this._windowLayerBackground.y = 82;
    this.addChild(this._windowLayerBackground);

    this._windowOptionsSprite = new Sprite();
    if(DataManager.isAnySavefileExists()) {
        this._windowOptionsSprite.bitmap = ImageManager.loadPicture("menuGlowneOpcje");
    } else {
        this._windowOptionsSprite.bitmap = ImageManager.loadPicture("menuGlowneOpcjeBezWczytaj");
    }
    this._windowOptionsSprite.x = 82;
    this._windowOptionsSprite.y = 286;
    this.addChild(this._windowOptionsSprite);
}

Scene_Title.prototype.createWindowLayer = function() {
    this.createWindowLayerBackground();
    var width = Graphics.boxWidth;
    var height = Graphics.boxHeight;
    var x = (Graphics.width - width) / 2;
    x = x - 420;
    var y = (Graphics.height - height) / 2;
    y = y - 182;
    this._windowLayer = new WindowLayer();
    this._windowLayer.move(x, y, width, height);
    this.addChild(this._windowLayer);
};

Scene_GameEnd.prototype.createWindowLayer = function() {
    var width = Graphics.boxWidth;
    var height = Graphics.boxHeight;
    var x = (Graphics.width - width) / 2;
    x = x - 420;
    var y = (Graphics.height - height) / 2;
    this._windowLayer = new WindowLayer();
    this._windowLayer.move(x, y, width, height);
    this.addChild(this._windowLayer);
};
